/* REXX UUEnCode 1.0 by Max Alekseyev, 2:5015/60 */

LPS=200 /* Lines per Section */

Say 'REXX UUEnCode 1.0 (c) 1998 by Max Alekseyev'
If Arg()=0 Then
Do
 Say 'Usage: ruuen InputName.Ext OutputName'
 Exit
End 

Parse Arg FileIn FileOut

Call Stream FileIn,'c','open read'

Size=Chars(FileIn)
If Size=0 Then
Do
 Say 'Empty file.'
 Exit
End
NumChars=(Size*4+2)%3
NumLines=(NumChars+59)%60
NumSect=(NumLines+LPS-1)%LPS
LPS=(NumLines+NumSect-1)%NumSect

AUCS=0; ABCS=0
In=FileSpec('name',FileIn)

Do s=1 to NumSect
 Say 'Writing section' s 'of' NumSect
 SUCS=0;
 Out = FileOut'.'Insert('',s,,3-Length(s),'0')
 Call Stream Out,'c','open write'
 Call LineOut Out,'section' s 'of' NumSect 'of file' In '< REXX UUEnCode 1.0 by RElf Dec. >'
 Call LineOut Out,''
 If s=1 Then Call LOut 'begin 644' In
 i=0; n=0; l=''
 Do Until (Chars(FileIn)=0) | (n=LPS)
  c=CharIn(FileIn,,3); lc=Length(c)
  Do j=1 to lc
   ABCS=(ABCS%2+ABCS//2*32768+C2D(SubStr(c,j,1)))//65536
  End
  c=C2D(c)*2**((6-lc*8//6)//6)
  d=2**(lc*6)
  Do lc+1
   b=c%d+32; c=c//d; d=d%64
   If b=32 then b=96
   l=l || D2C(b)
  End
  i=(i+1)//15
  If (i=0) & (lc=3) Then 
  Do 
   n=n+1
   Call LOut 'M'l
   l=''
  End
 End
 If l<>'' Then Call LOut D2C(Length(l)*3%4+32)l
 f='first encoded line'; d=0
 If s=1 Then 
 Do 
  f='"begin"'; d=11+Length(In) 
 End
 If s=NumSect Then 
 Do
  Call LOut '`'
  Call LOut 'end'
  Call LineOut Out,'sum -r/size' SUCS'/'NumChars-LPS*(s-1)*60+2*(NumLines-LPS*(s-1))+d+6 'section (from' f 'to "end")'
  Call LineOut Out,'sum -r/size' ABCS'/'AUCS 'entire input file'
 End
 Else 
 Do
   Call LineOut Out,''
   Call LineOut Out,'sum -r/size' SUCS'/'62*LPS+d 'section (from' f 'to last encoded line)'
 End
 Call Stream Out,'c','close'
End

Call Stream FileIn,'c','close'
Exit

LOut:
  t=Arg(1)
  Do j=1 to Length(t)
   AUCS=(AUCS%2+AUCS//2*32768+C2D(SubStr(t,j,1)))//65536
   SUCS=(SUCS%2+SUCS//2*32768+C2D(SubStr(t,j,1)))//65536 
  End
  AUCS=(AUCS%2+AUCS//2*32768+10)//65536
  SUCS=(SUCS%2+SUCS//2*32768+10)//65536 
  Call LineOut Out,t
Return
